// This file is automatically generated and not supposed to be modified.
using System;
using Boolean = System.Boolean;
using String = System.String;
using List = Android.Runtime.JavaList;
using Map = Android.Runtime.JavaDictionary;

namespace Rs.Core
{
	public interface ICoreInterface : global::Android.OS.IInterface
	{
		String CallExtension (String name, String @params);
		String GetExtensions ();
		bool IsExtensionsLoaded ();
		void ReloadExtensions ();
		void FireNfc ();
		String GetDeviceModel ();
		void ShowExtensionSettings (String name);
		void UnloadExtension (String name);
		byte [] ReadFile (String extension, String name);
		bool IsDeviceAvailable (String name);
		bool IsDeviceEnable (String name);
		void SetDeviceEnabled (String name, bool on);
		void Subscribe (String receiver);
		void Unsubscribe (String receiver);
		void NfcWrite (String map);
		String NfcWriteMap ();
		void NfcWriteDone (String id, String message);
		String AvailableDevices ();
		void GetResultIntent (String name);
		String GetDeviceId ();
		String GetDeviceSerial ();
		bool SetNFCKey (String key);
	}

	public abstract class ICoreInterfaceStub : global::Android.OS.Binder, global::Android.OS.IInterface, Rs.Core.ICoreInterface
	{
		const string descriptor = "rs.core.CoreInterface";
		public ICoreInterfaceStub ()
		{
			this.AttachInterface (this, descriptor);
		}

		public static Rs.Core.ICoreInterface AsInterface (global::Android.OS.IBinder obj)
		{
			if (obj == null)
				return null;
			var iin = (global::Android.OS.IInterface) obj.QueryLocalInterface (descriptor);
			if (iin != null && iin is Rs.Core.ICoreInterface)
				return (Rs.Core.ICoreInterface) iin;
			return new Proxy (obj);
		}

		public global::Android.OS.IBinder AsBinder ()
		{
			return this;
		}

		protected override bool OnTransact (int code, global::Android.OS.Parcel data, global::Android.OS.Parcel reply, int flags)
		{
			switch (code) {
			case global::Android.OS.BinderConsts.InterfaceTransaction:
				reply.WriteString (descriptor);
				return true;

			case TransactionCallExtension: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				String arg1 = default (String);
				arg1 = data.ReadString ();
				var result = this.CallExtension (arg0, arg1);
				reply.WriteNoException ();
				reply.WriteString (result);
				data.WriteString (arg0);
				data.WriteString (arg1);
				return true;
				}

			case TransactionGetExtensions: {
				data.EnforceInterface (descriptor);
				var result = this.GetExtensions ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionIsExtensionsLoaded: {
				data.EnforceInterface (descriptor);
				var result = this.IsExtensionsLoaded ();
				reply.WriteNoException ();
				reply.WriteInt (result ? 1 : 0);
				return true;
				}

			case TransactionReloadExtensions: {
				data.EnforceInterface (descriptor);
				this.ReloadExtensions ();
				reply.WriteNoException ();
				return true;
				}

			case TransactionFireNfc: {
				data.EnforceInterface (descriptor);
				this.FireNfc ();
				reply.WriteNoException ();
				return true;
				}

			case TransactionGetDeviceModel: {
				data.EnforceInterface (descriptor);
				var result = this.GetDeviceModel ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionShowExtensionSettings: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.ShowExtensionSettings (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionUnloadExtension: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.UnloadExtension (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionReadFile: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				String arg1 = default (String);
				arg1 = data.ReadString ();
				var result = this.ReadFile (arg0, arg1);
				reply.WriteNoException ();
				reply.WriteByteArray (result);
				data.WriteString (arg0);
				data.WriteString (arg1);
				return true;
				}

			case TransactionIsDeviceAvailable: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				var result = this.IsDeviceAvailable (arg0);
				reply.WriteNoException ();
				reply.WriteInt (result ? 1 : 0);
				data.WriteString (arg0);
				return true;
				}

			case TransactionIsDeviceEnable: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				var result = this.IsDeviceEnable (arg0);
				reply.WriteNoException ();
				reply.WriteInt (result ? 1 : 0);
				data.WriteString (arg0);
				return true;
				}

			case TransactionSetDeviceEnabled: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				bool arg1 = default (bool);
				arg1 = data.ReadInt () != 0;
				this.SetDeviceEnabled (arg0, arg1);
				reply.WriteNoException ();
				data.WriteString (arg0);
				data.WriteInt (arg1 ? 1 : 0);
				return true;
				}

			case TransactionSubscribe: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.Subscribe (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionUnsubscribe: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.Unsubscribe (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionNfcWrite: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.NfcWrite (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionNfcWriteMap: {
				data.EnforceInterface (descriptor);
				var result = this.NfcWriteMap ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionNfcWriteDone: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				String arg1 = default (String);
				arg1 = data.ReadString ();
				this.NfcWriteDone (arg0, arg1);
				reply.WriteNoException ();
				data.WriteString (arg0);
				data.WriteString (arg1);
				return true;
				}

			case TransactionAvailableDevices: {
				data.EnforceInterface (descriptor);
				var result = this.AvailableDevices ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionGetResultIntent: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				this.GetResultIntent (arg0);
				reply.WriteNoException ();
				data.WriteString (arg0);
				return true;
				}

			case TransactionGetDeviceId: {
				data.EnforceInterface (descriptor);
				var result = this.GetDeviceId ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionGetDeviceSerial: {
				data.EnforceInterface (descriptor);
				var result = this.GetDeviceSerial ();
				reply.WriteNoException ();
				reply.WriteString (result);
				return true;
				}

			case TransactionSetNFCKey: {
				data.EnforceInterface (descriptor);
				String arg0 = default (String);
				arg0 = data.ReadString ();
				var result = this.SetNFCKey (arg0);
				reply.WriteNoException ();
				reply.WriteInt (result ? 1 : 0);
				data.WriteString (arg0);
				return true;
				}

			}
			return base.OnTransact (code, data, reply, flags);
		}

		public class Proxy : Java.Lang.Object, Rs.Core.ICoreInterface
		{
			global::Android.OS.IBinder remote;

			public Proxy (global::Android.OS.IBinder remote)
			{
				this.remote = remote;
			}

			public global::Android.OS.IBinder AsBinder ()
			{
				return remote;
			}

			public string GetInterfaceDescriptor ()
			{
				return descriptor;
			}

			public String CallExtension (String name, String @params)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					__data.WriteString (@params);
					remote.Transact (ICoreInterfaceStub.TransactionCallExtension, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public String GetExtensions ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionGetExtensions, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public bool IsExtensionsLoaded ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
bool __result = default (bool);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionIsExtensionsLoaded, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadInt () != 0;

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public void ReloadExtensions ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionReloadExtensions, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public void FireNfc ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionFireNfc, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public String GetDeviceModel ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionGetDeviceModel, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public void ShowExtensionSettings (String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionShowExtensionSettings, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public void UnloadExtension (String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionUnloadExtension, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public byte [] ReadFile (String extension, String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
byte [] __result = default (byte []);

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (extension);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionReadFile, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.CreateByteArray ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public bool IsDeviceAvailable (String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
bool __result = default (bool);

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionIsDeviceAvailable, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadInt () != 0;

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public bool IsDeviceEnable (String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
bool __result = default (bool);

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionIsDeviceEnable, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadInt () != 0;

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public void SetDeviceEnabled (String name, bool on)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					__data.WriteInt (on ? 1 : 0);
					remote.Transact (ICoreInterfaceStub.TransactionSetDeviceEnabled, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public void Subscribe (String receiver)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (receiver);
					remote.Transact (ICoreInterfaceStub.TransactionSubscribe, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public void Unsubscribe (String receiver)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (receiver);
					remote.Transact (ICoreInterfaceStub.TransactionUnsubscribe, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public void NfcWrite (String map)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (map);
					remote.Transact (ICoreInterfaceStub.TransactionNfcWrite, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public String NfcWriteMap ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionNfcWriteMap, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public void NfcWriteDone (String id, String message)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (id);
					__data.WriteString (message);
					remote.Transact (ICoreInterfaceStub.TransactionNfcWriteDone, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public String AvailableDevices ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionAvailableDevices, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public void GetResultIntent (String name)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (name);
					remote.Transact (ICoreInterfaceStub.TransactionGetResultIntent, __data, __reply, 0);
					__reply.ReadException ();

				} finally {
					__data.Recycle ();
				}

			}


			public String GetDeviceId ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionGetDeviceId, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public String GetDeviceSerial ()
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
String __result = default (String);

				try {
					__data.WriteInterfaceToken (descriptor);
					remote.Transact (ICoreInterfaceStub.TransactionGetDeviceSerial, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadString ();

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


			public bool SetNFCKey (String key)
			{
				global::Android.OS.Parcel __data = global::Android.OS.Parcel.Obtain ();

				global::Android.OS.Parcel __reply = global::Android.OS.Parcel.Obtain ();
bool __result = default (bool);

				try {
					__data.WriteInterfaceToken (descriptor);
					__data.WriteString (key);
					remote.Transact (ICoreInterfaceStub.TransactionSetNFCKey, __data, __reply, 0);
					__reply.ReadException ();
					__result = __reply.ReadInt () != 0;

				} finally {
					__reply.Recycle ();
					__data.Recycle ();
				}
				return __result;

			}


		}

		internal const int TransactionCallExtension = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 0;

		internal const int TransactionGetExtensions = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 1;

		internal const int TransactionIsExtensionsLoaded = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 2;

		internal const int TransactionReloadExtensions = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 3;

		internal const int TransactionFireNfc = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 4;

		internal const int TransactionGetDeviceModel = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 5;

		internal const int TransactionShowExtensionSettings = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 6;

		internal const int TransactionUnloadExtension = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 7;

		internal const int TransactionReadFile = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 8;

		internal const int TransactionIsDeviceAvailable = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 9;

		internal const int TransactionIsDeviceEnable = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 10;

		internal const int TransactionSetDeviceEnabled = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 11;

		internal const int TransactionSubscribe = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 12;

		internal const int TransactionUnsubscribe = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 13;

		internal const int TransactionNfcWrite = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 14;

		internal const int TransactionNfcWriteMap = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 15;

		internal const int TransactionNfcWriteDone = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 16;

		internal const int TransactionAvailableDevices = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 17;

		internal const int TransactionGetResultIntent = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 18;

		internal const int TransactionGetDeviceId = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 19;

		internal const int TransactionGetDeviceSerial = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 20;

		internal const int TransactionSetNFCKey = global::Android.OS.Binder.InterfaceConsts.FirstCallTransaction + 21;

		public abstract String CallExtension (String name, String @params);

		public abstract String GetExtensions ();

		public abstract bool IsExtensionsLoaded ();

		public abstract void ReloadExtensions ();

		public abstract void FireNfc ();

		public abstract String GetDeviceModel ();

		public abstract void ShowExtensionSettings (String name);

		public abstract void UnloadExtension (String name);

		public abstract byte [] ReadFile (String extension, String name);

		public abstract bool IsDeviceAvailable (String name);

		public abstract bool IsDeviceEnable (String name);

		public abstract void SetDeviceEnabled (String name, bool on);

		public abstract void Subscribe (String receiver);

		public abstract void Unsubscribe (String receiver);

		public abstract void NfcWrite (String map);

		public abstract String NfcWriteMap ();

		public abstract void NfcWriteDone (String id, String message);

		public abstract String AvailableDevices ();

		public abstract void GetResultIntent (String name);

		public abstract String GetDeviceId ();

		public abstract String GetDeviceSerial ();

		public abstract bool SetNFCKey (String key);

	}
}
